
/////////////////////////////////////////////////////////////
//
// Source file for MainFormUI
//
//    This class implements the user interface created in 
//    RapidApp.
//
//    Restrict changes to those sections between
//    the "//--- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//
//
/////////////////////////////////////////////////////////////


#include "MainFormUI.h" // Generated header file for this class

#include <Xm/Form.h> 
#include <Xm/Frame.h> 
#include <Xm/Label.h> 
#include <Xm/LabelG.h> 
#include <Xm/Scale.h> 
#include <Xm/TextF.h> 
#include <Xm/ToggleB.h> 
#include <Vk/VkResource.h>
#include "pixmaps.h"  // constant and pixmap descriptions
#include <Vk/VkPixmap.h>


// Externally defined classes referenced by this class: 

#include <Vk/VkVuMeter.h>
//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations



// These are default resources for widgets in objects of this class
// All resources will be prepended by *<name> at instantiation,
// where <name> is the name of the specific instance, as well as the
// name of the baseWidget. These are only defaults, and may be overriden
// in a resource file by providing a more specific resource name

String  MainFormUI::_defaultMainFormUIResources[] = {
        "*label1.labelString:  Status:",
        "*label12.labelString:  Mic",
        "*label13.labelString:  Speaker",
        "*label2.labelString:  A/V Control",
        "*label3.labelString:  Switch:",
        "*manualToggle.labelString:  Manual",
        "*talkToggle.labelString:  Talk",
        "*toggle.labelString:  Camera",

        //---- Start editable code block: MainFormUI Default Resources


        //---- End editable code block: MainFormUI Default Resources

        (char*)NULL
};

MainFormUI::MainFormUI ( const char *name ) : VkComponent ( name ) 
{ 
    // No widgets are created by this constructor.
    // If an application creates a component using this constructor,
    // It must explictly call create at a later time.
    // This is mostly useful when adding pre-widget creation
    // code to a derived class constructor.

    //---- Start editable code block: MainForm constructor 2


    //---- End editable code block: MainForm constructor 2


}    // End Constructor




MainFormUI::MainFormUI ( const char *name, Widget parent ) : VkComponent ( name ) 
{ 
    //---- Start editable code block: MainForm pre-create


    //---- End editable code block: MainForm pre-create



    // Call creation function to build the widget tree.

     create ( parent );

    //---- Start editable code block: MainForm constructor


    //---- End editable code block: MainForm constructor


}    // End Constructor


MainFormUI::~MainFormUI() 
{
    // Base class destroys widgets

    //---- Start editable code block: MainFormUI destructor


    //---- End editable code block: MainFormUI destructor
}    // End destructor



void MainFormUI::create ( Widget parent )
{
    Arg      args[21];
    Cardinal count;
    count = 0;

    // Load any class-defaulted resources for this object

    setDefaultResources ( parent, _defaultMainFormUIResources  );


    // Create an unmanaged widget as the top of the widget hierarchy

    _baseWidget = _mainForm = XtVaCreateWidget ( _name,
                                                 xmFormWidgetClass,
                                                 parent, 
                                                 XmNresizePolicy, XmRESIZE_GROW, 
                                                 (XtPointer) NULL ); 

    // install a callback to guard against unexpected widget destruction

    installDestroyHandler();


    // Create widgets used in this component
    // All variables are data members of this class

    _toggle = XtVaCreateManagedWidget  ( "toggle",
                                          xmToggleButtonWidgetClass,
                                          _baseWidget, 
                                          XmNalignment, XmALIGNMENT_BEGINNING, 
                                          XmNlabelType, XmSTRING, 
                                          XmNindicatorSize, 10, 
                                          XmNindicatorType, Xm3D_N_OF_MANY, 
                                          XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET, 
                                          XmNbottomAttachment, XmATTACH_NONE, 
                                          XmNleftAttachment, XmATTACH_OPPOSITE_WIDGET, 
                                          XmNrightAttachment, XmATTACH_NONE, 
                                          XmNtopPosition, 0, 
                                          XmNbottomPosition, 0, 
                                          XmNleftPosition, 0, 
                                          XmNtopOffset, 185, 
                                          XmNbottomOffset, 0, 
                                          XmNleftOffset, 140, 
                                          XmNrightOffset, 0, 
                                          XmNwidth, 75, 
                                          XmNheight, 35, 
                                          (XtPointer) NULL ); 
    VkSetHighlightingPixmap ( _toggle, camerabmp );

    XtAddCallback ( _toggle,
                    XmNvalueChangedCallback,
                    &MainFormUI::cameraCallback,
                    (XtPointer) this ); 


    _statusText = XtVaCreateManagedWidget  ( "statusText",
                                              xmTextFieldWidgetClass,
                                              _baseWidget, 
                                              XmNeditable, False, 
                                              XmNtopAttachment, XmATTACH_FORM, 
                                              XmNbottomAttachment, XmATTACH_NONE, 
                                              XmNleftAttachment, XmATTACH_FORM, 
                                              XmNrightAttachment, XmATTACH_NONE, 
                                              XmNtopOffset, 245, 
                                              XmNbottomOffset, 0, 
                                              XmNleftOffset, 55, 
                                              XmNrightOffset, 0, 
                                              XmNwidth, 170, 
                                              XmNheight, 35, 
                                              (XtPointer) NULL ); 
    XtVaSetValues ( _statusText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _statusText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _label1 = XtVaCreateManagedWidget  ( "label1",
                                          xmLabelGadgetClass,
                                          _baseWidget, 
                                          XmNtopAttachment, XmATTACH_FORM, 
                                          XmNbottomAttachment, XmATTACH_NONE, 
                                          XmNleftAttachment, XmATTACH_FORM, 
                                          XmNrightAttachment, XmATTACH_NONE, 
                                          XmNtopOffset, 255, 
                                          XmNbottomOffset, 0, 
                                          XmNleftOffset, 0, 
                                          XmNrightOffset, 0, 
                                          XmNwidth, 55, 
                                          XmNheight, 20, 
                                          (XtPointer) NULL ); 


    _ctrlFrame = XtVaCreateManagedWidget  ( "ctrlFrame",
                                             xmFrameWidgetClass,
                                             _baseWidget, 
                                             XmNtopAttachment, XmATTACH_FORM, 
                                             XmNbottomAttachment, XmATTACH_NONE, 
                                             XmNleftAttachment, XmATTACH_FORM, 
                                             XmNrightAttachment, XmATTACH_NONE, 
                                             XmNleftPosition, 0, 
                                             XmNtopOffset, 5, 
                                             XmNbottomOffset, 0, 
                                             XmNleftOffset, 0, 
                                             XmNrightOffset, 0, 
                                             XmNwidth, 225, 
                                             XmNheight, 236, 
                                             (XtPointer) NULL ); 


    _ctrlForm = XtVaCreateManagedWidget  ( "ctrlForm",
                                            xmFormWidgetClass,
                                            _ctrlFrame, 
                                            XmNresizePolicy, XmRESIZE_GROW, 
                                            XmNwidth, 219, 
                                            XmNheight, 230, 
                                            (XtPointer) NULL ); 


    _label13 = XtVaCreateManagedWidget  ( "label13",
                                           xmLabelWidgetClass,
                                           _ctrlForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 20, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 75, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 60, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _label12 = XtVaCreateManagedWidget  ( "label12",
                                           xmLabelWidgetClass,
                                           _ctrlForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 20, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 10, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 30, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _talkToggle = XtVaCreateManagedWidget  ( "talkToggle",
                                              xmToggleButtonWidgetClass,
                                              _ctrlForm, 
                                              XmNalignment, XmALIGNMENT_BEGINNING, 
                                              XmNlabelType, XmSTRING, 
                                              XmNrecomputeSize, False, 
                                              XmNindicatorSize, 10, 
                                              XmNindicatorType, Xm3D_N_OF_MANY, 
                                              XmNtopAttachment, XmATTACH_FORM, 
                                              XmNbottomAttachment, XmATTACH_NONE, 
                                              XmNleftAttachment, XmATTACH_FORM, 
                                              XmNrightAttachment, XmATTACH_NONE, 
                                              XmNtopOffset, 105, 
                                              XmNbottomOffset, 0, 
                                              XmNleftOffset, 135, 
                                              XmNrightOffset, 0, 
                                              XmNwidth, 75, 
                                              XmNheight, 65, 
                                              (XtPointer) NULL ); 

    XtAddCallback ( _talkToggle,
                    XmNvalueChangedCallback,
                    &MainFormUI::talkCallback,
                    (XtPointer) this ); 


    _manualToggle = XtVaCreateManagedWidget  ( "manualToggle",
                                                xmToggleButtonWidgetClass,
                                                _ctrlForm, 
                                                XmNalignment, XmALIGNMENT_BEGINNING, 
                                                XmNlabelType, XmSTRING, 
                                                XmNtopAttachment, XmATTACH_FORM, 
                                                XmNbottomAttachment, XmATTACH_NONE, 
                                                XmNleftAttachment, XmATTACH_FORM, 
                                                XmNrightAttachment, XmATTACH_NONE, 
                                                XmNtopOffset, 70, 
                                                XmNbottomOffset, 0, 
                                                XmNleftOffset, 135, 
                                                XmNrightOffset, 0, 
                                                XmNwidth, 75, 
                                                XmNheight, 28, 
                                                (XtPointer) NULL ); 

    XtAddCallback ( _manualToggle,
                    XmNvalueChangedCallback,
                    &MainFormUI::manualSwitchCallback,
                    (XtPointer) this ); 


    _label3 = XtVaCreateManagedWidget  ( "label3",
                                          xmLabelGadgetClass,
                                          _ctrlForm, 
                                          XmNtopAttachment, XmATTACH_FORM, 
                                          XmNbottomAttachment, XmATTACH_NONE, 
                                          XmNleftAttachment, XmATTACH_FORM, 
                                          XmNrightAttachment, XmATTACH_NONE, 
                                          XmNtopOffset, 45, 
                                          XmNbottomOffset, 0, 
                                          XmNleftOffset, 140, 
                                          XmNrightOffset, 0, 
                                          XmNwidth, 55, 
                                          XmNheight, 20, 
                                          (XtPointer) NULL ); 


    /*
    _speakerScale = XtVaCreateManagedWidget  ( "speakerScale",
                                                xmScaleWidgetClass,
                                                _ctrlForm, 
                                                XmNorientation, XmVERTICAL, 
                                                XmNshowValue, True, 
                                                XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET, 
                                                XmNbottomAttachment, XmATTACH_NONE, 
                                                XmNleftAttachment, XmATTACH_WIDGET, 
                                                XmNrightAttachment, XmATTACH_NONE, 
                                                XmNtopPosition, 0, 
                                                XmNleftPosition, 0, 
                                                XmNtopOffset, 10, 
                                                XmNbottomOffset, 0, 
                                                XmNleftOffset, -4, 
                                                XmNrightOffset, 0, 
                                                XmNwidth, 25, 
                                                XmNheight, 190, 
                                                (XtPointer) NULL ); 
    */

    _speakerMeter = new VkVuMeter( "speakerMeter", _ctrlForm  );
    _speakerMeter->show();


    _micScale = XtVaCreateManagedWidget  ( "micScale",
                                            xmScaleWidgetClass,
                                            _ctrlForm, 
                                            XmNorientation, XmVERTICAL, 
                                            XmNshowValue, True, 
                                            XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET, 
                                            XmNbottomAttachment, XmATTACH_NONE, 
                                            XmNleftAttachment, XmATTACH_WIDGET, 
                                            XmNrightAttachment, XmATTACH_NONE, 
                                            XmNtopPosition, 0, 
                                            XmNleftPosition, 0, 
                                            XmNtopOffset, 10, 
                                            XmNbottomOffset, 0, 
                                            XmNleftOffset, 0, 
                                            XmNrightOffset, 0, 
                                            XmNwidth, 25, 
                                            XmNheight, 190, 
                                            (XtPointer) NULL ); 

    XtAddCallback ( _micScale,
                    XmNvalueChangedCallback,
                    &MainFormUI::micScaleCallback,
                    (XtPointer) this ); 

    _label2 = XtVaCreateManagedWidget  ( "label2",
                                          xmLabelGadgetClass,
                                          _ctrlForm, 
                                          XmNtopAttachment, XmATTACH_FORM, 
                                          XmNbottomAttachment, XmATTACH_NONE, 
                                          XmNleftAttachment, XmATTACH_FORM, 
                                          XmNrightAttachment, XmATTACH_NONE, 
                                          XmNtopOffset, 0, 
                                          XmNbottomOffset, 0, 
                                          XmNleftOffset, 0, 
                                          XmNrightOffset, 0, 
                                          XmNwidth, 85, 
                                          XmNheight, 20, 
                                          (XtPointer) NULL ); 


    _micMeter = new VkVuMeter( "micMeter", _ctrlForm  );
    _micMeter->show();


    /*
    XtVaSetValues ( _speakerScale, 
                    XmNtopWidget, _speakerMeter->baseWidget(),
                    XmNleftWidget, _speakerMeter->baseWidget(),
                    (XtPointer) NULL );
    */
    XtVaSetValues ( _speakerMeter->baseWidget(),
                    XmNtopAttachment, XmATTACH_FORM, 
                    XmNbottomAttachment, XmATTACH_NONE, 
                    XmNleftAttachment, XmATTACH_FORM, 
                    XmNrightAttachment, XmATTACH_NONE, 
                    XmNtopOffset, 30, 
                    XmNbottomOffset, 0, 
                    XmNleftOffset, 80, 
                    XmNrightOffset, 0, 
                    XmNwidth, 20, 
                    XmNheight, 199, 
                    (XtPointer) NULL );
    XtVaSetValues ( _micScale, 
                    XmNtopWidget, _micMeter->baseWidget(),
                    XmNleftWidget, _micMeter->baseWidget(),
                    (XtPointer) NULL );
    XtVaSetValues ( _micMeter->baseWidget(),
                    XmNtopAttachment, XmATTACH_FORM, 
                    XmNbottomAttachment, XmATTACH_NONE, 
                    XmNleftAttachment, XmATTACH_FORM, 
                    XmNrightAttachment, XmATTACH_NONE, 
                    XmNtopOffset, 30, 
                    XmNbottomOffset, 0, 
                    XmNleftOffset, 10, 
                    XmNrightOffset, 0, 
                    XmNwidth, 20, 
                    XmNheight, 200, 
                    (XtPointer) NULL );
    XtVaSetValues ( _toggle, 
                    XmNtopWidget, _ctrlFrame, 
                    XmNleftWidget, _ctrlFrame, 
                    (XtPointer) NULL );

    //---- Start editable code block: MainFormUI create


    //---- End editable code block: MainFormUI create
}

const char * MainFormUI::className()
{
    return ("MainFormUI");
}    // End className()




/////////////////////////////////////////////////////////////// 
// The following functions are static member functions used to 
// interface with Motif.
/////////////////////////////////// 

void MainFormUI::cameraCallback ( Widget    w,
                                  XtPointer clientData,
                                  XtPointer callData ) 
{ 
    MainFormUI* obj = ( MainFormUI * ) clientData;
    obj->camera ( w, callData );
}

void MainFormUI::manualSwitchCallback ( Widget    w,
                                        XtPointer clientData,
                                        XtPointer callData ) 
{ 
    MainFormUI* obj = ( MainFormUI * ) clientData;
    obj->manualSwitch ( w, callData );
}

void MainFormUI::talkCallback ( Widget    w,
                                XtPointer clientData,
                                XtPointer callData ) 
{ 
    MainFormUI* obj = ( MainFormUI * ) clientData;
    obj->talk ( w, callData );
}

void MainFormUI::micScaleCallback ( Widget    w,
                                XtPointer clientData,
                                XtPointer callData ) 
{ 
    MainFormUI* obj = ( MainFormUI * ) clientData;
    obj->micScale ( w, callData );
}



/////////////////////////////////////////////////////////////// 
// The following functions are called from the menu items 
// in this window.
/////////////////////////////////// 

void MainFormUI::camera ( Widget, XtPointer ) 
{
    // This virtual function is called from cameraCallback.
    // This function is normally overriden by a derived class.

}

void MainFormUI::manualSwitch ( Widget, XtPointer ) 
{
    // This virtual function is called from manualSwitchCallback.
    // This function is normally overriden by a derived class.

}

void MainFormUI::talk ( Widget, XtPointer ) 
{
    // This virtual function is called from talkCallback.
    // This function is normally overriden by a derived class.

}

void MainFormUI::micScale ( Widget, XtPointer ) 
{
    // This virtual function is called from talkCallback.
    // This function is normally overriden by a derived class.

}



//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code
